LeetCode 154. Find Minimum in Rotated Sorted Array II - 二分查找(Binary Search)系列题10

Suppose an array of length n sorted in ascending order is rotated between 1 and n times. For example, the array nums = [0,1,4,4,5,6,7] might become:

  • [4,5,6,7,0,1,4] if it was rotated 4 times.
  • [0,1,4,4,5,6,7] if it was rotated 7 times.

Notice that rotating an array [a[0], a[1], a[2], ..., a[n-1]] 1 time results in the array [a[n-1], a[0], a[1], a[2], ..., a[n-2]].

Given the sorted rotated array nums that may contain duplicates, return the minimum element of this array.

You must decrease the overall operation steps as much as possible.

Example 1:

Input: nums = [1,3,5]
Output: 1

Example 2:

Input: nums = [2,2,2,0,1]
Output: 0

Constraints:

  • n == nums.length
  • 1 <= n <= 5000
  • -5000 <= nums[i] <= 5000
  • nums is sorted and rotated between 1 and n times.

Follow up: This problem is similar to Find Minimum in Rotated Sorted Array, but nums may contain duplicates. Would this affect the runtime complexity? How and why?

这题是LeetCode 153. Find Minimum in Rotated Sorted Array的拓展,解题思路跟LeetCode 81. Search in Rotated Sorted Array II一样,都是因为数组可能有重复数字使得前一题用到的判断条件不成立。

前一题LeetCode 153. Find Minimum in Rotated Sorted Array通过中点值与最右边值比较,如果nums[mid] < nums[right],右半区间是递增的,最小值可以确定一定在左半区间(包含nums[mid]),反之最小值一定在右半区间。但是当有重复数值,就可能出现nums[mid]等于nums[right]的情况,使得最小值不确定是在哪个区间,因此只需要把这种情况排除掉。

class Solution:
    def findMin(self, nums: List[int]) -> int:
        l, r = 0, len(nums) - 1
        
        while l < r:
            mid = l + (r - l) // 2
            if nums[mid] == nums[r]:
                r -= 1 
                continue
                
            if nums[mid] < nums[r]:
                r = mid
            else:
                l = mid + 1
            
        return nums[l]        

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值